// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/ShaderStage.hpp"

namespace Dawn {

  class IShaderProgram {
    protected:
      std::vector<std::shared_ptr<ShaderStage>> stages;

    public:
      /**
       * Initialize the IShaderProgram2 object
       * 
       * @param stages The list of shader stages to initialize with.
       */
      virtual void init(
        const std::vector<std::shared_ptr<ShaderStage>> &stages
      ) = 0;

      /**
       * Destroy the IShaderProgram2 object
       */
      virtual ~IShaderProgram();
  };
}